## libreswan 3.23

=== linux/Makefile ===
# FreeS/WAN subdir makefile
# Copyright (C) 1998-2001  Henry Spencer.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

LIBRESWANSRCDIR?=$(shell cd .. && pwd)
#SUBDIRS=net/ipsec

include $(LIBRESWANSRCDIR)/Makefile.inc

def:
	@echo "Please read doc/intro.html or INSTALL before running make"
	@false

cleanall install programs man check clean modules install_file_list:
	@true

#	@for d in $(SUBDIRS); \
#	do \
#		(cd $$d && $(MAKE) TOPDIR=${KERNELSRC} LIBRESWANSRCDIR=$(LIBRESWANSRCDIR)/.. $@ ) || exit 1 ; \
#	done

=== programs/Makefile ===
# Makefile for the KLIPS interface utilities
#
# Copyright (C) 1998, 1999  Henry Spencer.
# Copyright (C) 1999, 2000, 2001  Richard Guy Briggs
# Copyright (C) 2012 Paul Wouters <paul@libreswan.org>
# Copyright (C) 2015,2017 Andrew Cagney
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

ifndef top_srcdir
include ../mk/dirs.mk
endif
include $(top_srcdir)/Makefile.inc

SUBDIRS=

SUBDIRS+=pluto
SUBDIRS+=whack
SUBDIRS+=proc addconn
SUBDIRS+=configs _keycensor _plutorun _stackmanager
SUBDIRS+=_secretcensor _updown _unbound-hook
SUBDIRS+=auto barf verify show ipsec look newhostkey
SUBDIRS+=rsasigkey setup showhostkey
SUBDIRS+=readwriteconf
SUBDIRS+=_import_crl
SUBDIRS+=algparse
SUBDIRS+=cavp

ifeq ($(USE_KLIPS),true)
SUBDIRS+= _updown.klips eroute klipsdebug pf_key spi spigrp tncfg
endif
ifeq ($(USE_MAST),true)
SUBDIRS+= _updown.mast
endif
ifeq ($(USE_NETKEY),true)
SUBDIRS+= _updown.netkey
endif
ifeq ($(USE_BSDKAME),true)
SUBDIRS+=_realsetup.bsd _updown.bsdkame
endif

include $(top_srcdir)/mk/subdirs.mk

=== testing/Makefile ===
# Testing root makefile, for libreswan
#
# Copyright (C) 2015,2017 Andrew Cagney <cagney@gnu.org>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

SUBDIRS = pluto
SUBDIRS += enumcheck

ifndef top_srcdir
include ../mk/dirs.mk
endif
include $(top_srcdir)/mk/subdirs.mk

=== initsystems/docker/Makefile ===
LIBRESWANSRCDIR?=$(shell cd ../..; pwd)
SRCDIR?=${LIBRESWANSRCDIR}/initsystems/docker/

INITDFILE=ipsec.init
SYSCONFIGFILE=sysconfig.pluto
SUBDIRS=
INITDDIR=$(RCDIR)
SYSCONFIGDIR=$(SYSCONFDIR)/sysconfig
SYSVINIT_DEFAULT_START?=

include ${LIBRESWANSRCDIR}/Makefile.inc

programs:     initdfiles sysconfigfiles
initdfiles:   $(INITDFILE)
sysconfigfiles: $(SYSCONFIGFILE)
install:      programs doinstall
install-programs: doinstall

doinstall: programs installinitfiles installsysconfig checkenabled

installinitfiles:
	mkdir -p $(INITDDIR)
	$(INSTALL) $(INITDFILE) $(INITDDIR)/ipsec

installsysconfig:
	mkdir -p $(SYSCONFIGDIR)
	if test ! -f $(SYSCONFIGDIR)/pluto ; then \
		$(INSTALL) $(INSTCONFFLAGS) $(SYSCONFIGFILE) $(SYSCONFIGDIR)/pluto ; \
	fi

checkenabled:
	@count=0 ; \
	for dir in $(DESTDIR)/etc/rc?.d ; do \
		if test -f $$dir/S??ipsec.init ; then \
			count=1 ; \
		fi ; \
	done ; \
	if test $$count = 0 ; then \
		echo "************************** WARNING ***********************************" ; \
		echo "** The ipsec service is not enabled." ; \
		echo "** Enable it using 'chkconfig ipsec on' or another similar method." ; \
		echo "**********************************************************************" ; \
	fi

%: ${SRCDIR}%.in ${LIBRESWANSRCDIR}/Makefile.inc ${LIBRESWANSRCDIR}/Makefile.ver
	@echo  'IN' $< '->' $@
	${TRANSFORM_VARIABLES} < $< | sed -e "s:@SYSVINIT_DEFAULT_START@:${SYSVINIT_DEFAULT_START}:g" > $@
	@if [ -x $< ]; then chmod +x $@; fi
	@if [ "${PROGRAM}.in" = $< ]; then chmod +x $@; fi

=== initsystems/openrc/Makefile ===
LIBRESWANSRCDIR?=$(shell cd ../..; pwd)
SRCDIR?=${LIBRESWANSRCDIR}/initsystems/openrc/

INITDFILE=ipsec.init
SUBDIRS=
INITDDIR=$(RCDIR)

include ${LIBRESWANSRCDIR}/Makefile.inc

programs:     ipsec.init
initdfiles:   $(INITDFILE)
install:      programs doinstall
install-programs: doinstall

doinstall: programs installinitfiles checkenabled

installinitfiles:
	mkdir -p $(INITDDIR)
	$(INSTALL) $(INITDFILE) $(INITDDIR)/ipsec

checkenabled:
	@echo checkenabled not yet implemented

%: ${SRCDIR}%.in ${LIBRESWANSRCDIR}/Makefile.inc ${LIBRESWANSRCDIR}/Makefile.ver
	@echo  'IN' $< '->' $@
	${TRANSFORM_VARIABLES} < $< > $@
	@if [ -x $< ]; then chmod +x $@; fi
	@if [ "${PROGRAM}.in" = $< ]; then chmod +x $@; fi

=== initsystems/systemd/Makefile ===
ifndef top_srcdir
include ../../mk/dirs.mk
endif

UNITDIR=$(shell pkg-config systemd --variable=systemdsystemunitdir)
SYSTEMDFILE=ipsec.service
SYSTEMDDIR=$(DESTDIR)$(UNITDIR)

include $(top_srcdir)/Makefile.inc

local-base: $(SYSTEMDFILE)

# Use dependencies to force the order: LOCAL-BASE,
# INSTALLSYSTEMDSERVICE, OLDINITDCHECK, POSTCHECK.
#
# (Without this, since local-install-base depends local-base, rules
# like local-base and installsystemdservice are allowed to run in
# parallel)

local-install-base: installsystemdservice oldinitdcheck postcheck

installsystemdservice: local-base
	@mkdir -p $(SYSTEMDDIR)
	$(INSTALL) $(INSTCONFFLAGS) $(builddir)/$(SYSTEMDFILE) $(SYSTEMDDIR)
	@if test $(SYSTEMDDIR) = $(UNITDIR) ; then \
		systemctl --system daemon-reload ; \
	fi

oldinitdcheck: installsystemdservice
	@if test -f $(DESTDIR)/etc/init.d/ipsec* ; then \
		if egrep -i '(openswan|libreswan)' $(DESTDIR)/etc/init.d/ipsec* > /dev/null 2>&1 ; then \
			echo "WARNING: removing older SYSV style init files" ; \
			echo "removing: " $(DESTDIR)/etc/init.d/ipsec* $(DESTDIR)/etc/rc*.d/[KS][0-9][0-9]ipsec* ; \
			rm -f $(DESTDIR)/etc/init.d/ipsec* $(DESTDIR)/etc/rc*.d/[KS][0-9][0-9]ipsec* ; \
		else \
			echo "************************** WARNING ***********************************" ; \
			echo "old " $(DESTDIR)/etc/init.d/ipsec* " files were found; these should be removed" ; \
			echo "**********************************************************************" ; \
		fi ; \
	fi

postcheck: installsystemdservice oldinitdcheck
	@if test -z "$(DESTDIR)" -a $(SYSTEMDDIR) = $(UNITDIR) -a $(shell systemctl is-enabled ipsec.service) = "disabled" ; then \
		echo "DESTDIR='$(DESTDIR)'" ; \
		echo "************************** WARNING ***********************************" ; \
		echo "The ipsec service is currently disabled. To enable this service issue:" ; \
		echo " systemctl enable ipsec.service" ; \
		echo "**********************************************************************" ; \
	fi ; \
	if test -z "$(DESTDIR)" -a $(shell systemctl is-active ipsec.service) = "disabled" ; then \
		echo "The ipsec service is currently disabled. To enable this service on boot issue:" ; \
		echo " systemctl enable ipsec.service" ; \
	fi ; \
	if test -z "$(DESTDIR)" -a $(shell systemctl is-active ipsec.service) = "active" ; then \
		echo "************************** WARNING ***********************************" ; \
		echo "The ipsec service is currently running. You need to restart the service using:" ; \
		echo " systemctl restart ipsec.service" ; \
		echo "**********************************************************************" ; \
	fi

# XXX: identical to program.mk?

%: %.in $(top_srcdir)/Makefile.inc $(top_srcdir)/Makefile.ver
	@echo  'IN' $< '->' $(builddir)/$@
	$(TRANSFORM_VARIABLES) < $< > $(builddir)/$@
	@if [ -x $< ]; then chmod +x $(builddir)/$@; fi
	@if [ "$(PROGRAM).in" = $< ]; then chmod +x $(builddir)/$@; fi

include ${top_srcdir}/mk/targets.mk

=== initsystems/sysvinit/Makefile ===
LIBRESWANSRCDIR?=$(shell cd ../..; pwd)
SRCDIR?=${LIBRESWANSRCDIR}/initsystems/sysvinit/

INITDFILE=ipsec.init
SYSCONFIGFILE=sysconfig.pluto
SUBDIRS=
INITDDIR=$(RCDIR)
SYSCONFIGDIR=$(SYSCONFDIR)/sysconfig
SYSVINIT_DEFAULT_START?=

include ${LIBRESWANSRCDIR}/Makefile.inc

programs:     initdfiles sysconfigfiles
initdfiles:   $(INITDFILE)
sysconfigfiles: $(SYSCONFIGFILE)
install:      programs doinstall
install-programs: doinstall

doinstall: programs installinitfiles installsysconfig checkenabled

installinitfiles:
	mkdir -p $(INITDDIR)
	$(INSTALL) $(INITDFILE) $(INITDDIR)/ipsec

installsysconfig:
	mkdir -p $(SYSCONFIGDIR)
	if test ! -f $(SYSCONFIGDIR)/pluto ; then \
		$(INSTALL) $(INSTCONFFLAGS) $(SYSCONFIGFILE) $(SYSCONFIGDIR)/pluto ; \
	fi

checkenabled:
	@count=0 ; \
	for dir in $(DESTDIR)/etc/rc?.d ; do \
		if test -f $$dir/S??ipsec.init ; then \
			count=1 ; \
		fi ; \
	done ; \
	if test $$count = 0 ; then \
		echo "************************** WARNING ***********************************" ; \
		echo "** The ipsec service is not enabled." ; \
		echo "** Enable it using 'chkconfig ipsec on' or another similar method." ; \
		echo "**********************************************************************" ; \
	fi

%: ${SRCDIR}%.in ${LIBRESWANSRCDIR}/Makefile.inc ${LIBRESWANSRCDIR}/Makefile.ver
	@echo  'IN' $< '->' $@
	${TRANSFORM_VARIABLES} < $< | sed -e "s:@SYSVINIT_DEFAULT_START@:${SYSVINIT_DEFAULT_START}:g" > $@
	@if [ -x $< ]; then chmod +x $@; fi
	@if [ "${PROGRAM}.in" = $< ]; then chmod +x $@; fi

=== initsystems/upstart/Makefile ===
LIBRESWANSRCDIR?=$(shell cd ../..; pwd)
SRCDIR?=${LIBRESWANSRCDIR}/initsystems/systemd/

UPSTARTFILE=ipsec.conf
DEFAULTFILE=default.pluto
SUBDIRS=
UPSTARTDIR=$(SYSCONFDIR)/init
DEFAULTDIR=$(SYSCONFDIR)/default

include ${LIBRESWANSRCDIR}/Makefile.inc

programs:     upstartfiles defaultfiles
upstartfiles: $(UPSTARTFILE)
defaultfiles: $(DEFAULTFILE)
install:      programs doinstall
install-programs: doinstall

doinstall: programs installupstartconf installdefault

installupstartconf:
	@mkdir -p $(UPSTARTDIR)
	$(INSTALL) $(UPSTARTFILE) $(UPSTARTDIR);

installdefault:
	mkdir -p $(DEFAULTDIR)
	if test ! -f $(DEFAULTDIR)/pluto ; then \
		$(INSTALL) $(DEFAULTFILE) $(DEFAULTDIR)/pluto ; \
	fi

%: ${SRCDIR}%.in ${LIBRESWANSRCDIR}/Makefile.inc ${LIBRESWANSRCDIR}/Makefile.ver
	@echo  'IN' $< '->' $@
	${TRANSFORM_VARIABLES} < $< > $@
	@if [ -x $< ]; then chmod +x $@; fi
	@if [ "${PROGRAM}.in" = $< ]; then chmod +x $@; fi

=== lib/libcrypto/Makefile ===
# Makefile for pluto/userspace crypto libraries
#
# Copyright (C) 2005 Michael Richardson <mcr@xelerance.com>
# Copyright (C) 2012 Paul Wouters <paul@libreswan.org>
# Copyright (C) 2015 Andrew Cagney <cagney@gnu.org>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

ifndef top_srcdir
include ../../mk/dirs.mk
endif

include $(top_srcdir)/Makefile.inc

ifeq ($(USE_SERPENT),true)
SUBDIRS+=libserpent
endif
ifeq ($(USE_TWOFISH),true)
SUBDIRS+=libtwofish
endif

include $(top_srcdir)/mk/subdirs.mk

=== lib/libipsecconf/Makefile ===
# Libreswan library for parsing configuration files
#
# Copyright (C) 2005 Michael Richardson <mcr@xelerance.com> Xelerance Corporation
# Copyright (C) 2012 Paul Wouters <paul@libreswan.org>
# Copyright (C) 2015 Andrew Cagney <cagney@gnu.org>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

LIBRARY=ipsecconf
LIB=lib${LIBRARY}.a
MANDIR=$(MANTREE)/man3

SRCS=confread.c confwrite.c starterwhack.c starterlog.c
SRCS+=parser.tab.c lex.yy.c keywords.c
SRCS+=interfaces.c
SRCS+=addr_lookup.c

OBJS=${SRCS:.c=.o}

# pick up generated LEX/YACC files
INCLUDES += -I$(builddir)

ifdef top_srcdir
include ${top_srcdir}/mk/library.mk
else
include ../../mk/library.mk
endif

# Hack to force the generated files to be built first.  Not too bad
# since all the $(OBJS) indirectly depend on the header anyway.
$(OBJS): $(builddir)/parser.tab.h

# Avoid flex bugs:
#
# - flex 3.5.4 (centos 5) doesn't allow a space between the '-o'
#   option and the file name.
#
#   Fortunately later versions of flex seem to handle this.
#
# - flex < 2.5.35 generates an invalid extern
#
#   Use sed to strip this out.
#
# - flex on RHEL 7 generates code that provokes GCC to warn
#   about comparing a signed value with an unsigned value
#   (Combination of a new GCC and an old flex).
#
#   Adding one cast makes RHEL 6's GCC unhappy, so we add two.
#   On RHEL 6, i is int and _yybytes_len is int.
#   On RHEL 7, i is int and _yybytes_len is yy_size_t
#   On Fedora 21, i is yy_size_t and _yybytes_len is yy_size_t
#   On some architectures, yy_size_t is wider than int;
#   which makes a mixed comparison OK.
#
# - flex 2.6.0-11 and gcc 4:5.3.1-3 on debian testing (2016-06-18)
#   also warns about comparisons of different kinds, so we add a third
#   fix.
#
# - avoid sed -i which somehow causes unwritable files on fedora 20
#   with 9p filesystem mount.

LEX = flex

$(builddir)/lex.yy.c: parser.l
	: no space between -o and scratch output file
	$(LEX) -o$@.tmp $<
	sed -e 's/for ( i = 0; i < _yybytes_len; ++i )$$/for ( i = 0; (yy_size_t)i < (yy_size_t)_yybytes_len; ++i )/' \
	    -e '/^extern int isatty.*$$/d' \
	    -e 's/if ((int) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {$$/if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {/' \
	    < $@.tmp > $@.sedtmp
	rm $@.tmp
	: install result
	mv $@.sedtmp $@

# Use wild card rule so that GNU Make knows that both are output from
# a single recipe.
# - sed command for workaround for older bison vs GCC warning
# - avoid sed -i which somehow causes unwritable files
#   on fedora 20 with 9p filesystem mount
# - avoid creating the target file until it is done
# - $* matches %
#
# - run bison from the builddir so that parser.tab.h defines
#   YY_YY_PARSER_TAB_H_INCLUDED and not a macro containing the
#   buildpath.  See parser-controls.h for why.

ifeq ($(USE_YACC),true)
BISON=yacc -b parser
else
BISON=bison
endif

$(builddir)/%.tab.h $(builddir)/%.tab.c: %.y
	cd $(builddir) && $(BISON) ${BISONOSFLAGS} -v --defines=$*.tab.h -o $*.tab.c.tmp $(abs_srcdir)/$*.y
	sed -e '/^ *#/s/if YYENABLE_NLS/if defined(YYENABLE_NLS) \&\& YYENABLE_NLS/' \
	    -e '/^ *#/s/if YYLTYPE_IS_TRIVIAL/if defined(YYLTYPE_IS_TRIVIAL) \&\& YYLTYPE_IS_TRIVIAL/' \
	    < $(builddir)/$*.tab.c.tmp >  $(builddir)/$*.tab.c.sedtmp
	rm $(builddir)/$*.tab.c.tmp
	mv $(builddir)/$*.tab.c.sedtmp $(builddir)/$*.tab.c

clean: parser-clean
.PHONY: parser-clean
parser-clean:
	cd $(builddir) && $(RM) -f *.tab.[cdho] *.dot *.output lex.yy.[cdho] *tmp

=== lib/liblswtool/Makefile ===
# Libreswan library for standalone logging
#
# Copyright (C) 2017 Andrew Cagney <cagney@gnu.org>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

LIB = liblswtool.a

OBJS += lswlog.o
OBJS += libreswan_exit.o

ifdef top_srcdir
include ${top_srcdir}/mk/library.mk
else
include ../../mk/library.mk
endif

=== lib/libswan/Makefile ===
# Libreswan library

# Copyright (C) 1998-2001  Henry Spencer.
# Copyright (C) 2003, 2004 Xelerance Corporation
# Copyright (C) 2012 Paul Wouters <pwouters@redhat.com>
# Copyright (C) 2012-2013 Paul Wouters <paul@libreswan.org>
# Copyright (C) 2015-2017 Andrew Cagney
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

#
# XXX:
#
# Because libswan's Makefile tests USE_... variables, defined in
# config.mk, using "ifeq", it needs to include that file early.
#
# Instead:
#
# - replace the code with '$(call if-enabled)'.
#
# - move the optional files to their own library?
#

ifndef top_srcdir
include ../../mk/dirs.mk
endif
include $(top_srcdir)/mk/config.mk

LIB = libswan.a

OBJS += x509dn.o asn1.o oid.o

OBJS += addrtoa.o addrtot.o addrtypeof.o alg_info.o esp_info.o anyaddr.o \
	constants.o datatot.o \
	alloc.o diag.o \
	goodmask.o id.o initaddr.o initsaid.o initsubnet.o \
	iprange.o \
        keyblobtoid.o \
	kernel_alg.o lex.o \
	lswconf.o \
	lswfips.o \
	rangetosubnet.o sameaddr.o \
	satot.o secrets.o subnetof.o subnettoa.o subnettot.o \
	subnettypeof.o ttoaddr.o ttodata.o ttoprotoport.o \
	ttorange.o ttosa.o ttosubnet.o ttoul.o ultot.o \
	secitem_chunk.o \
	base64_rsa_pubkey.o \
	lswnss.o \
	lsw_passert_fail.o \
	libreswan_log.o \
	libreswan_loglog.o \
	alg_byname.o

OBJS += ip_address.o

OBJS += lmod.o
OBJS += deltatime.o
OBJS += realtime.o
OBJS += monotime.o

OBJS += debug_enum_names.o
OBJS += libreswan_DBG_dump.o
OBJS += libreswan_DBG_log.o

OBJS += lswlog.o
OBJS += lswlog_dbg.o
OBJS += lswlog_nss_error.o
OBJS += lswlog_nss_ckm.o
OBJS += lswlog_nss_ckf.o
OBJS += lswlog_nss_cka.o
OBJS += lswlog_source_line.o
OBJS += lswlog_sanitized.o
OBJS += lswlog_errno.o
OBJS += lswlog_bytes.o
OBJS += lswlog_enum_lset_short.o
OBJS += lswlog_realtime.o
OBJS += lswlog_deltatime.o
OBJS += lswlog_monotime.o
OBJS += lswlog_ip.o
OBJS += lswlog_sensitive_ip.o
OBJS += lswlog_to_file_stream.o
OBJS += lswlog_pexpect.o
OBJS += lswlog_passert.o

# Crypto code:
#
# XXX: More is comming as it gets cleaned up and made more library
# like.

# not much left using this
CFLAGS += -I$(top_srcdir)/lib/libcrypto

OBJS += ike_alg_desc.o
ifeq ($(USE_3DES),true)
OBJS += ike_alg_3des.o
endif
OBJS += ike_alg_aes.o
OBJS += ike_alg_camellia.o
ifeq ($(USE_CAST),true)
OBJS += ike_alg_cast.o
endif
OBJS += ike_alg_dh.o
OBJS += ike_alg_md5.o
OBJS += ike_alg_null.o
ifeq ($(USE_RIPEMD),true)
OBJS += ike_alg_ripemd.o
endif
ifeq ($(USE_SERPENT),true)
OBJS += ike_alg_serpent.o
endif
OBJS += ike_alg_sha1.o
OBJS += ike_alg_sha2.o
ifeq ($(USE_TWOFISH),true)
OBJS += ike_alg_twofish.o
endif

ifeq ($(NSS_REQ_AVA_COPY),true)
OBJS += nss_copies.o
endif

ifeq ($(USE_UNBOUND_EVENT_H_COPY),true)
CFLAGS+=-I${LIBRESWANSRCDIR}/include/unbound
endif

ifeq ($(USE_DNSSEC),true)
OBJS += unbound.o
endif

OBJS += sanitizestring.o pfkey_print.o pfkey_sock.o pfkey_error.o

ifeq ($(USE_KLIPS),true)
CFLAGS += -DKLIPS
endif

ifeq ($(USE_PFKEYv2),true)
CFLAGS += -DPFKEYV2
OBJS += pfkey_v2_build.o pfkey_v2_ext_bits.o pfkey_v2_parse.o
OBJS += pfkey_v2_debug.o
endif

CFLAGS+=-I${LIBRESWANSRCDIR}/lib/libcrypto/libsha2
CFLAGS+=-I${LIBRESWANSRCDIR}/lib/libcrypto/libaes_xcbc

KLIPSSRCDIR?=${LIBRESWANSRCDIR}/linux/net/ipsec

VPATH+= ${KLIPSSRCDIR}

# Original flags; this is a mess.
CFLAGS+=${PORTINCLUDE} -I. -I${KLIPSSRCDIR} -I${KLIPSINC}
CFLAGS+=-I${LIBRESWANSRCDIR}
CFLAGS+= $(NSSFLAGS)
CFLAGS+=-I${LIBRESWANSRCDIR}/include ${PORTINCLUDE}
# XXX: hack until everything uses a consistent .c.o rule
CFLAGS+=$(USERLAND_CFLAGS)
CFLAGS+=${CROSSFLAGS}

ifeq ($(NSS_REQ_AVA_COPY),true)
CFLAGS+=-DNSS_REQ_AVA_COPY
endif

OBJS += $(abs_builddir)/version.o

include $(top_srcdir)/mk/library.mk

# build version.c using version number from Makefile.ver
$(abs_builddir)/version.c: ${KLIPSSRCDIR}/version.in.c $(top_srcdir)/Makefile.ver
	rm -f $@.tmp
	sed -e '/"/s/@IPSECVERSION@/$(IPSECVERSION)/' \
	    -e '/"/s/@IPSECVIDVERSION@/$(IPSECVIDVERSION)/' \
	    ${KLIPSSRCDIR}/version.in.c \
	    > $@.tmp
	mv $@.tmp $@

# developer-only stuff

test-%: %.c
	${CC} ${CFLAGS} -D`echo $* | tr 'a-z' 'A-Z'`_MAIN $*.c -o test-$*

l:
	$(MAKE) $(LIB) ARFLAGS=crv CFLAGS=-O
	$(RANLIB) $(LIB)

t:	$(LIB)
	ln -f -s ${KLIPSSRCDIR}/ttosubnet.c try1a.c
	${CC} ${CFLAGS} -DTTOSUBNET_MAIN try1a.c $(LIB) -o try1a
	./try1a -r
	ln -f -s ${KLIPSSRCDIR}/ttodata.c try2.c
	${CC} ${CFLAGS} -DTTODATA_MAIN try2.c $(LIB) -o try2
	./try2 -r
	ln -f -s ${KLIPSSRCDIR}/ttosa.c try4a.c
	${CC} ${CFLAGS} -DTTOSA_MAIN try4a.c $(LIB) -o try4a
	./try4a -r
	ln -f -s ${KLIPSSRCDIR}/rangetosubnet.c try6.c
	${CC} ${CFLAGS} -DRANGETOSUBNET_MAIN try6.c $(LIB) -o try6
	./try6 -r
	ln -f -s ${KLIPSSRCDIR}/addrtot.c try7.c
	${CC} ${CFLAGS} -DADDRTOT_MAIN try7.c $(LIB) -o try7
	./try7 -r

=== debian/changelog ===
libreswan (3.23-4) unstable; urgency=medium

  * d/tests/control: isolation-container → isolation-machine

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 15 Feb 2018 12:03:58 -0500

libreswan (3.23-3) unstable; urgency=medium

  * d/tests/opportunistic: more details on failure

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 14 Feb 2018 13:08:09 -0500

libreswan (3.23-2) unstable; urgency=medium

  * d/tests/opportunistic: do not fail on initial systemctl status
  * d/control: Rules-Requires-Root: no

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 13 Feb 2018 10:59:46 -0500

libreswan (3.23-1) unstable; urgency=medium

  [ Daniel Kahn Gillmor ]
  * New upstream release
  * drop patches already upstream, refresh remaining patches

  [ Antony Antony ]
  * tests/opportunistic fix, asymetric dnssec test

  [ Daniel Kahn Gillmor ]
  * d/copyright: Format: use https
  * d/copyright: remove dropped file
  * avoid lintian complaint by skipping my skipped test :P
    (override_dh_auto_test-does-not-check-DEB_BUILD_PROFILES)
  * quit persecuting Antony Antony, again
  * fix spelling

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 05 Feb 2018 16:23:59 -0500

libreswan (3.22-4) unstable; urgency=medium

  * conflict with strongswan-libcharon (Closes: #886842)
  * Standards-Version: bump to 4.1.3 (no changes needed)
  * move to debhelper 11
  * Vcs: move to salsa.debian.org
  * clean up lintian overrides

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 10 Jan 2018 12:01:37 -0500

libreswan (3.22-3) unstable; urgency=medium

  * add more dependencies to autopkgtest

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 13 Nov 2017 02:56:05 +0800

libreswan (3.22-2) unstable; urgency=medium

  * fix debian c-i test so that it can ping

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 11 Nov 2017 15:46:44 +0800

libreswan (3.22-1) unstable; urgency=medium

  * new upstream release
  * drop patches already applied upstream
  * include two new patches as requested by upstream
  * include ipsec version from upstream release (Closes: #879614)
  * Standards-Version: bump to 4.1.1 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 11 Nov 2017 14:02:02 +0800

libreswan (3.21-2) unstable; urgency=medium

  [ Antony Antony ]
  * add systemd build dependency
  * Revert "USE_DNSSEC=false b/c upstream needs libunbound to link to libevent"
  * up libunbound2 build dependency to 1.6.5

  [ Daniel Kahn Gillmor ]
  * bump standards-version to 4.1.0 (no changes needed)
  * move to python3 instead of python
  * accept Antony Antony's name for real
  * avoid lintian griping that we cannot fix
  * fix spelling

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 26 Sep 2017 02:39:40 -0400

libreswan (3.21-1) experimental; urgency=medium

  * New upstream release
  * use systemd presets for default-disabled service
  * ensure that /run/pluto exists
  * add dependency on iptables
  * update build-dependencies to match upstream expectations
  * Standards-Version: bump to 4.0.1 (no changes needed)
  * Initial attempt at autopkgtest
  * USE_DNSSEC=false b/c upstream needs libunbound to link to libevent
    (and it does not, see #871675)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 10 Aug 2017 23:24:56 -0400

libreswan (3.21~rc5-1) experimental; urgency=medium

  [ Daniel Kahn Gillmor ]
  * new upstream release-candidate
  * bump Standards-Version to 4.0.0 (no changes needed)

  [ Antony Antony ]
  * add dns-root-data dependency and use root.key from it

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 26 Jun 2017 16:56:09 -0400

libreswan (3.21~rc2-1) experimental; urgency=medium

  * new upstream release-candidate

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 02 Jun 2017 09:58:40 -0400

=== debian/control ===
Source: libreswan
Section: net
Priority: optional
Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Uploaders:
 Paul Wouters <paul@libreswan.org>,
 Ondřej Surý <ondrej@debian.org>,
Vcs-Browser: https://salsa.debian.org/debian/libreswan
Vcs-Git: https://salsa.debian.org/debian/libreswan.git
Standards-Version: 4.1.3
Rules-Requires-Root: no
Build-Depends:
 bison,
 bzip2,
 debhelper (>= 11~),
 flex,
 htmldoc,
 libaudit-dev [linux-any],
 libcap-ng-dev [linux-any],
 libcurl4-nss-dev,
 libevent-dev,
 libkrb5-dev,
 libldap2-dev,
 libldns-dev,
 libnspr4-dev,
 libnss3-dev (>= 3.16.1),
 libnss3-tools,
 libpam0g-dev,
 libselinux1-dev [linux-any],
 libsystemd-dev,
 libunbound-dev (>= 1.6.5~),
 man2html,
 pkg-config,
 po-debconf,
 systemd,
 xmlto,
Homepage: https://libreswan.org/

Package: libreswan
Architecture: any
Pre-Depends:
 debconf | debconf-2.0,
Depends:
 bsdmainutils,
 dns-root-data,
 host,
 iproute2 | iproute (>= 20071016),
 iptables,
 libnspr4,
 libnss3 (>= 3.16),
 libnss3-tools,
 libunbound2,
 systemd,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 python3,
Provides:
 ike-server,
Conflicts:
 ike-server,
 strongswan-libcharon,
 strongswan-starter,
Replaces:
 ike-server,
Description: Internet Key Exchange daemon
 Libreswan is an IPsec implementation for Linux. It has support for most
 of the extensions (RFC + IETF drafts) related to IPsec, including
 IKEv2, X.509 Digital Certificates, NAT Traversal, and many others.
 .
 Libreswan has been forked from Openswan 2.6.38, which was forked from
 FreeS/WAN 1.99.
 .
 The Libreswan IKE daemon is named pluto. It was inherited from the FreeS/WAN
 project, but provides improved X.509 certificate support and other features.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@

# this should track the definition of USERCOMPILE in mk/userland-cflags.mk:43
# but without -fstack-protector-all for arches that lack stack-protector
ifneq (,$(filter $(DEB_HOST_ARCH), hppa alpha))
export USERCOMPILE = -fexceptions -fno-strict-aliasing -fPIE -DPIE
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  ENABLE_SELINUX = USE_LABELED_IPSEC=true USE_LINUX_AUDIT=true
  ENABLE_LIBCAP_NG = USE_LIBCAP_NG=true
else
  ENABLE_SELINUX = USE_LABELED_IPSEC=false USE_LINUX_AUDIT=false
  ENABLE_LIBCAP_NG = USE_LIBCAP_NG=false
endif

override_dh_auto_build:
	$(MAKE) programs \
		IPSECVERSION=$(DEB_VERSION_UPSTREAM) \
		INC_USRLOCAL=/usr \
		FINALLIBEXECDIR=/usr/lib/ipsec \
		PUBDIR=/usr/sbin \
		INC_MANDIR=share/man \
		FINALNSSDIR=/var/lib/ipsec/nss \
		USE_LDAP=true \
		USE_LIBCURL=true \
		USE_XAUTHPAM=true \
		USE_FIPSCHECK=false \
		$(ENABLE_LIBCAP_NG) \
		$(ENABLE_SELINUX) \
		USE_KLIPS=false \
		USE_DNSSEC=true \
		DEFAULT_DNSSEC_ROOTKEY_FILE=/usr/share/dns/root.key

override_dh_auto_install-arch:
	# Add here commands to install the package into debian/libreswan
	$(MAKE) install \
		INC_USRLOCAL=/usr \
		FINALLIBEXECDIR=/usr/lib/ipsec \
		INC_MANDIR=share/man \
		FINALNSSDIR=/var/lib/ipsec/nss \
		PUBDIR=$(CURDIR)/debian/libreswan/usr/sbin \
		USE_KLIPS=false \
		DESTDIR=$(CURDIR)/debian/libreswan

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "Skip dh_auto_test"
endif

## libreswan 3.25

=== debian/changelog ===
libreswan (3.25-1) unstable; urgency=medium

  * new upstream release
  * refresh patches

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 27 Jun 2018 12:46:44 -0400

libreswan (3.23-6) unstable; urgency=medium

  * avoid -fstack-protector-all on ia64

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 19 Jun 2018 22:39:57 -0400

libreswan (3.23-5) unstable; urgency=medium

  * move to DEP-14 branch naming
  * Standards-Version: bump to 4.1.4 (no changes needed)
  * d/rules: drop unneeded PUBDIR definitions
  * drop spelling-error lintian overrides about Antony Antony (no longer needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 18 Jun 2018 12:45:39 -0400

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Ondřej Surý <ondrej@debian.org>,
 Vcs-Browser: https://salsa.debian.org/debian/libreswan
 Vcs-Git: https://salsa.debian.org/debian/libreswan.git
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Rules-Requires-Root: no
 Build-Depends:
  bison,

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 # this should track the definition of USERCOMPILE in mk/userland-cflags.mk:43
 # but without -fstack-protector-all for arches that lack stack-protector
-ifneq (,$(filter $(DEB_HOST_ARCH), hppa alpha))
+ifneq (,$(filter $(DEB_HOST_ARCH), hppa alpha ia64))
 export USERCOMPILE = -fexceptions -fno-strict-aliasing -fPIE -DPIE
 endif
 
@@ -24,7 +24,6 @@
 		IPSECVERSION=$(DEB_VERSION_UPSTREAM) \
 		INC_USRLOCAL=/usr \
 		FINALLIBEXECDIR=/usr/lib/ipsec \
-		PUBDIR=/usr/sbin \
 		INC_MANDIR=share/man \
 		FINALNSSDIR=/var/lib/ipsec/nss \
 		USE_LDAP=true \
@@ -44,7 +43,6 @@
 		FINALLIBEXECDIR=/usr/lib/ipsec \
 		INC_MANDIR=share/man \
 		FINALNSSDIR=/var/lib/ipsec/nss \
-		PUBDIR=$(CURDIR)/debian/libreswan/usr/sbin \
 		USE_KLIPS=false \
 		DESTDIR=$(CURDIR)/debian/libreswan

## libreswan 3.27

=== testing/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the
 # Free Software Foundation; either version 2 of the License, or (at your
-# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
 #
 # This program is distributed in the hope that it will be useful, but
 # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY

=== initsystems/systemd/Makefile ===
--- 
+++ 
@@ -8,8 +8,6 @@
 
 include $(top_srcdir)/Makefile.inc
 
-local-base: $(SYSTEMDFILE)
-
 # Use dependencies to force the order: LOCAL-BASE,
 # INSTALLSYSTEMDSERVICE, OLDINITDCHECK, POSTCHECK.
 #
@@ -17,14 +15,23 @@
 # like local-base and installsystemdservice are allowed to run in
 # parallel)
 
+local-base: $(builddir)/$(SYSTEMDFILE)
+
 local-install-base: installsystemdservice oldinitdcheck postcheck
 
-installsystemdservice: local-base
-	@mkdir -p $(SYSTEMDDIR)
+installsystemdservice: local-base | $(SYSTEMDDIR)
 	$(INSTALL) $(INSTCONFFLAGS) $(builddir)/$(SYSTEMDFILE) $(SYSTEMDDIR)
 	@if test $(SYSTEMDDIR) = $(UNITDIR) ; then \
+		echo running: systemctl --system daemon-reload; \
 		systemctl --system daemon-reload ; \
 	fi
+	@if test -f $(DESTDIR)/$(FINALLIBEXECDIR)/portexcludes; then \
+		echo fixing port excludes ; \
+		sed -Ei 's@^# (.*/portexcludes)$$@\1@' $(SYSTEMDDIR)/$(SYSTEMDFILE); \
+	fi
+
+$(SYSTEMDDIR):
+	mkdir -p $(SYSTEMDDIR)
 
 oldinitdcheck: installsystemdservice
 	@if test -f $(DESTDIR)/etc/init.d/ipsec* ; then \
@@ -60,10 +67,11 @@
 
 # XXX: identical to program.mk?
 
-%: %.in $(top_srcdir)/Makefile.inc $(top_srcdir)/Makefile.ver
-	@echo  'IN' $< '->' $(builddir)/$@
-	$(TRANSFORM_VARIABLES) < $< > $(builddir)/$@
-	@if [ -x $< ]; then chmod +x $(builddir)/$@; fi
-	@if [ "$(PROGRAM).in" = $< ]; then chmod +x $(builddir)/$@; fi
+$(builddir)/%: $(srcdir)/%.in $(top_srcdir)/Makefile.inc $(top_srcdir)/Makefile.ver | $(builddir)
+	@echo  'IN' $< '->' $@
+	$(TRANSFORM_VARIABLES) < $< > $@
+	@if [ -x $< ]; then chmod +x $@; fi
+	@if [ "$(PROGRAM).in" = $< ]; then chmod +x $@; fi
 
 include ${top_srcdir}/mk/targets.mk
+include ${top_srcdir}/mk/builddir.mk

=== programs/tncfg/Makefile ===
# Makefile for the KLIPS interface utilities
# Copyright (C) 1998, 1999  Henry Spencer.
# Copyright (C) 1999, 2000, 2001  Richard Guy Briggs
# Copyright (C) 2017 Andrew Cagney <cagney@gnu.org>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

PROGRAM=tncfg
OBJS += $(PROGRAM).o
OBJS += $(LIBRESWANLIB)
OBJS += $(LSWTOOLLIBS)
MANPAGES += ipsec_$(PROGRAM).5

ifdef top_srcdir
include $(top_srcdir)/mk/program.mk
else
include ../../mk/program.mk
endif

=== debian/changelog ===
libreswan (3.27-6+deb10u1) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * DoS attack via malicious IKEv1 informational exchange message
    (CVE-2020-1763) (Closes: #960458)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 13 May 2020 05:33:51 +0200

libreswan (3.27-6) unstable; urgency=medium

  * fix CVE-2019-10155 (closes: #930338)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 10 Jun 2019 23:04:05 +0100

libreswan (3.27-5) unstable; urgency=medium

  * fix CVE-2019-12312 (Closes: #929916)
  * bump Standards-Version to 4.3.0 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 03 Jun 2019 19:36:16 -0400

libreswan (3.27-4) unstable; urgency=medium

  * order object files for reproducible linking

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 16 Oct 2018 10:27:14 -0400

libreswan (3.27-3) unstable; urgency=medium

  * explicitly set ARCH for reproducibility

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 15 Oct 2018 16:07:00 -0400

libreswan (3.27-2) unstable; urgency=medium

  * avoid Curve25519 when building against nss that does not support it
  * backport patch from upstream to clean up ia64 build

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 15 Oct 2018 13:21:24 -0400

libreswan (3.27-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 12 Oct 2018 16:55:36 -0400

libreswan (3.26-1) unstable; urgency=medium

  * new upstream release (Closes: #909291)
  * refresh patches
  * import two patches from upstream to avoid FTBFS

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 27 Sep 2018 19:24:35 -0400

libreswan (3.25-2) unstable; urgency=medium

  * remove explicit list of libraries from Depends (Closes: #909203)
  * bump Standards-Version to 4.2.1 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 21 Sep 2018 02:35:42 -0400

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Ondřej Surý <ondrej@debian.org>,
 Vcs-Browser: https://salsa.debian.org/debian/libreswan
 Vcs-Git: https://salsa.debian.org/debian/libreswan.git
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Rules-Requires-Root: no
 Build-Depends:
  bison,
@@ -46,10 +46,7 @@
  host,
  iproute2 | iproute (>= 20071016),
  iptables,
- libnspr4,
- libnss3 (>= 3.16),
  libnss3-tools,
- libunbound2,
  systemd,
  ${misc:Depends},
  ${shlibs:Depends},

=== debian/rules ===
--- 
+++ 
@@ -19,8 +19,11 @@
   ENABLE_LIBCAP_NG = USE_LIBCAP_NG=false
 endif
 
+CV25519_AVAILABILITY=$(shell if grep -q SEC_OID_CURVE25519 /usr/include/nss/secoidt.h; then echo true; else echo false; fi)
+
 override_dh_auto_build:
 	$(MAKE) programs \
+		ARCH=$(DEB_HOST_ARCH) \
 		IPSECVERSION=$(DEB_VERSION_UPSTREAM) \
 		INC_USRLOCAL=/usr \
 		FINALLIBEXECDIR=/usr/lib/ipsec \
@@ -32,6 +35,7 @@
 		USE_FIPSCHECK=false \
 		$(ENABLE_LIBCAP_NG) \
 		$(ENABLE_SELINUX) \
+		USE_DH31=$(CV25519_AVAILABILITY) \
 		USE_KLIPS=false \
 		USE_DNSSEC=true \
 		DEFAULT_DNSSEC_ROOTKEY_FILE=/usr/share/dns/root.key
@@ -39,6 +43,7 @@
 override_dh_auto_install-arch:
 	# Add here commands to install the package into debian/libreswan
 	$(MAKE) install \
+		ARCH=$(DEB_HOST_ARCH) \
 		INC_USRLOCAL=/usr \
 		FINALLIBEXECDIR=/usr/lib/ipsec \
 		INC_MANDIR=share/man \

## libreswan 3.27.1

=== programs/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the
 # Free Software Foundation; either version 2 of the License, or (at your
-# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
 #
 # This program is distributed in the hope that it will be useful, but
 # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
@@ -34,6 +34,10 @@
 SUBDIRS+=algparse
 SUBDIRS+=cavp
 
+ifeq ($(USE_PORTEXCLUDES),true)
+SUBDIRS+=portexcludes
+endif
+
 ifeq ($(USE_KLIPS),true)
 SUBDIRS+= _updown.klips eroute klipsdebug pf_key spi spigrp tncfg
 endif

=== lib/libipsecconf/Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the
 # Free Software Foundation; either version 2 of the License, or (at your
-# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
 #
 # This program is distributed in the hope that it will be useful, but
 # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
@@ -21,7 +21,6 @@
 SRCS=confread.c confwrite.c starterwhack.c starterlog.c
 SRCS+=parser.tab.c lex.yy.c keywords.c
 SRCS+=interfaces.c
-SRCS+=addr_lookup.c
 
 OBJS=${SRCS:.c=.o}

=== lib/libswan/Makefile ===
# Libreswan library

# Copyright (C) 1998-2001  Henry Spencer.
# Copyright (C) 2003, 2004 Xelerance Corporation
# Copyright (C) 2012 Paul Wouters <pwouters@redhat.com>
# Copyright (C) 2012-2013 Paul Wouters <paul@libreswan.org>
# Copyright (C) 2015-2018 Andrew Cagney
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

#
# XXX:
#
# Because libswan's Makefile tests USE_... variables, defined in
# config.mk, using "ifeq", it needs to include that file early.
#
# Instead:
#
# - replace the code with '$(call if-enabled)'.
#
# - move the optional files to their own library?
#

ifndef top_srcdir
include ../../mk/dirs.mk
endif
include $(top_srcdir)/mk/config.mk

LIB = libswan.a

OBJS += x509dn.o asn1.o oid.o

OBJS += constants.o \
	alloc.o diag.o \
	id.o initaddr.o initsaid.o initsubnet.o \
	iprange.o \
        keyblobtoid.o \
	lex.o \
	lswconf.o \
	lswfips.o \
	rangetosubnet.o sameaddr.o \
	secrets.o subnettot.o \
	subnettypeof.o ttoaddr.o ttodata.o ttoprotoport.o \
	ttorange.o ttosa.o ttosubnet.o ttoul.o \
	secitem_chunk.o \
	base64_pubkey.o \
	lswnss.o \
	lsw_passert_fail.o \
	alg_byname.o

ifeq ($(USE_NETKEY),true)
OBJS += addr_lookup.o
endif

OBJS += fd.o
OBJS += kernel_alg.o
OBJS += kernel_sadb.o

# These get pulled in from the klips kernel code.
VPATH += ${KLIPSSRCDIR}
OBJS += addrtot.o
OBJS += addrtypeof.o
OBJS += anyaddr.o
OBJS += datatot.o
OBJS += goodmask.o
OBJS += satot.o
OBJS += ultot.o

OBJS += alg_info.o esp_info.o ike_info.o ah_info.o

OBJS += ckaid.o

OBJS += chunk.o
OBJS += shunk.o

OBJS += ip_address.o

OBJS += lmod.o
OBJS += deltatime.o
OBJS += realtime.o
OBJS += monotime.o

OBJS += debug.o
OBJS += impair.o
OBJS += keywords.o

OBJS += libreswan_DBG_dump.o
OBJS += libreswan_DBG_log.o
OBJS += libreswan_exit_log_errno.o
OBJS += libreswan_log_errno.o
OBJS += libreswan_pexpect.o
OBJS += libreswan_pexpect_log.o
OBJS += libreswan_bad_case.o

OBJS += rate_log.o

OBJS += libreswan_log.o
OBJS += libreswan_log_rc.o

OBJS += lswlog.o
OBJS += lswlog_dbg.o
OBJS += lswlog_nss_error.o
OBJS += lswlog_nss_ckm.o
OBJS += lswlog_nss_ckf.o
OBJS += lswlog_nss_cka.o
OBJS += lswlog_nss_secitem.o
OBJS += lswlog_source_line.o
OBJS += lswlog_sanitized.o
OBJS += lswlog_errno.o
OBJS += lswlog_bytes.o
OBJS += lswlog_enum_lset_short.o
OBJS += lswlog_realtime.o
OBJS += lswlog_deltatime.o
OBJS += lswlog_monotime.o
OBJS += lswlog_ip.o
OBJS += lswlog_sensitive_ip.o
OBJS += lswlog_to_file_stream.o
OBJS += lswlog_pexpect.o
OBJS += lswlog_passert.o

# Crypto code:
#
# XXX: More is coming as it gets cleaned up and made more library
# like.

# not much left using this
CFLAGS += -I$(top_srcdir)/lib/libcrypto

OBJS += ike_alg.o
OBJS += ike_alg_test.o
OBJS += ike_alg_encrypt_chacha20_poly1305.o
OBJS += ike_alg_encrypt_nss_aead_ops.o
OBJS += ike_alg_encrypt_nss_cbc_ops.o
OBJS += ike_alg_encrypt_nss_ctr_ops.o
OBJS += ike_alg_encrypt_nss_gcm_ops.o
OBJS += ike_alg_desc.o
ifeq ($(USE_3DES),true)
OBJS += ike_alg_3des.o
endif
OBJS += ike_alg_aes.o
OBJS += ike_alg_camellia.o
ifeq ($(USE_CAST),true)
OBJS += ike_alg_cast.o
endif
OBJS += ike_alg_dh.o
OBJS += ike_alg_md5.o
OBJS += ike_alg_none.o
ifeq ($(USE_RIPEMD),true)
OBJS += ike_alg_ripemd.o
endif
ifeq ($(USE_SERPENT),true)
OBJS += ike_alg_serpent.o
endif
OBJS += ike_alg_sha1.o
OBJS += ike_alg_sha2.o
ifeq ($(USE_TWOFISH),true)
OBJS += ike_alg_twofish.o
endif

ifeq ($(NSS_REQ_AVA_COPY),true)
OBJS += nss_copies.o
endif

ifeq ($(USE_UNBOUND_EVENT_H_COPY),true)
CFLAGS+=-I${LIBRESWANSRCDIR}/include/unbound
endif

ifeq ($(USE_DNSSEC),true)
OBJS += unbound.o
endif

OBJS += sanitizestring.o
OBJS += pfkey_sock.o pfkey_error.o

ifeq ($(USE_KLIPS),true)
CFLAGS += -DKLIPS
endif

ifeq ($(USE_PFKEYv2),true)
CFLAGS += -DPFKEYV2
OBJS += pfkey_v2_build.o pfkey_v2_ext_bits.o pfkey_v2_parse.o
OBJS += pfkey_v2_debug.o
endif

# Original flags; this is a mess.
CFLAGS+=${PORTINCLUDE} -I. -I${KLIPSINC}
CFLAGS+=-I${LIBRESWANSRCDIR}
CFLAGS+= $(NSSFLAGS)
CFLAGS+=-I${LIBRESWANSRCDIR}/include ${PORTINCLUDE}
# XXX: hack until everything uses a consistent .c.o rule
CFLAGS+=$(USERLAND_CFLAGS)
CFLAGS+=${CROSSFLAGS}

ifeq ($(NSS_REQ_AVA_COPY),true)
CFLAGS+=-DNSS_REQ_AVA_COPY
endif

OBJS += $(abs_builddir)/version.o

include $(top_srcdir)/mk/library.mk

# build version.c using version number from Makefile.ver
$(abs_builddir)/version.c: ${KLIPSSRCDIR}/version.in.c $(top_srcdir)/Makefile.ver
	rm -f $@.tmp
	sed -e '/"/s/@IPSECVERSION@/$(IPSECVERSION)/' \
	    -e '/"/s/@IPSECVIDVERSION@/$(IPSECVIDVERSION)/' \
	    ${KLIPSSRCDIR}/version.in.c \
	    > $@.tmp
	mv $@.tmp $@

=== programs/_keycensor/Makefile ===
# Makefile for miscellaneous programs
# Copyright (C) 2002  Michael Richardson	<mcr@freeswan.org>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

PROGRAM=_keycensor

ifdef top_srcdir
include $(top_srcdir)/mk/program.mk
else
include ../../mk/program.mk
endif

=== programs/spi/Makefile ===
# Makefile for the KLIPS interface utilities
# Copyright (C) 1998, 1999  Henry Spencer.
# Copyright (C) 1999, 2000, 2001  Richard Guy Briggs
# Copyright (C) 2008 Michael Richardson <mcr@sandelman.ca>
# Copyright (C) 2017 Andrew Cagney <cagney@gnu.org>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

PROGRAM=spi

MANPAGES += ipsec_$(PROGRAM).5

OBJS += $(PROGRAM).o

#
# XXX: For the moment build things by pulling in chunks of pluto.
# What, if anything, should be moved to libswan or another library?
#
CFLAGS += -I$(top_srcdir)/programs/pluto
PLUTOOBJS += $(patsubst %.c,%.o,$(notdir $(wildcard $(top_srcdir)/programs/pluto/ike_alg*.c)))
PLUTOOBJS += crypt_symkey.o
PLUTOOBJS += crypt_hash.o
PLUTOOBJS += test_buffer.o
PLUTOOBJS += ikev1_prf.o
PLUTOOBJS += ikev2_prf.o
PLUTOOBJS += crypt_prf.o
PLUTOOBJS += crypt_dh.o
PLUTOOBJS += crypt_utils.o
# Need absolute path as 'make' (check dependencies) and 'ld' (do link)
# are run from different directories.
OBJS += $(addprefix $(abs_top_builddir)/programs/pluto/, $(PLUTOOBJS))
# $(PROGRAM): pluto-base
# .PHONY: pluto-base
# pluto-base:
#	$(MAKE) -C $(top_srcdir)/programs/pluto base

OBJS += $(LIBRESWANLIB)
OBJS += $(LSWTOOLLIBS)

OBJS += $(LIBSERPENT)
OBJS += $(LIBTWOFISH)

LDFLAGS += $(NSS_LDFLAGS)
LDFLAGS += $(NSPR_LDFLAGS)

ifdef top_srcdir
include $(top_srcdir)/mk/program.mk
else
include ../../mk/program.mk
endif

=== debian/changelog ===
libreswan (3.27.1-6+deb10u1+dde) unstable; urgency=medium

  * update

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 06 Jul 2021 10:11:58 +0800

libreswan (3.27.1-6+deb10u1+dde) buster-security; urgency=high

  * Non-maintainer upload.
  * Update version.

 -- wangpei <wangpei@uniontech.com>  Wed, 30 Jun 2021 14:45:23 +0800
